(function(util) {
    define(['jquery', 'core/log'], function ($, log) {

        var public = {};

        public.DATA_ATTRIBUTE = {};
        public.USER_PREFERENCE = {};

        public.DATA_ATTRIBUTE.COURSE_SECTION_ID = 'data-{theme_name}-course-section-id'; //TODO: change {theme_name}
        public.DATA_ATTRIBUTE.IS_COLLAPSED = 'data-{theme_name}-is-collapsed'; //TODO: change {theme_name}
        public.COLLAPSE_CONTROLLER = '.course-format--topics__topic__header';

        // Currently viewed course topics collapse state.
        var _courseCollapseStates = {};

        function _topicsCollapseStatesPreferenceName(courseid) {
            return 'theme_basis/topics_collapse_state--' + courseid;
        }

        function _topicClickHandler(event) {
            var courseID = event.data.courseID;
            var $topic = $(this);  // jQuery event handlers 'this' bound to target element.
            var sectionID = $topic.attr(public.DATA_ATTRIBUTE.COURSE_SECTION_ID);
            var currentState = $topic.attr(public.DATA_ATTRIBUTE.IS_COLLAPSED);

            var $tar = $(event.target);
            var $controller = $topic.find(public.COLLAPSE_CONTROLLER);

            //Check that we're clicking on the collapse controller before handling click
            if ($tar.is($controller) || $controller.find($tar).length) {
                // Reverse the value of the current state.
                _courseCollapseStates[sectionID] = (currentState === '1') ? '0' : '1';

                $topic.attr(public.DATA_ATTRIBUTE.IS_COLLAPSED, _courseCollapseStates[sectionID]);

                util.set_user_preference(_topicsCollapseStatesPreferenceName(courseID), JSON.stringify(_courseCollapseStates));
            }
        }

        public.init = function (courseID, collapseStates) {

            // Initialisation pattern ensuring this function
            // can only be executed once.
            public.init = function () {};

            _courseCollapseStates = collapseStates;

            log.debug('{theme_name}/format-topics::init()'); //TODO: change {theme_name}

            $('.course-format--topics__topic').on('click', {'courseID': courseID}, _topicClickHandler);

        };

        return public;
    });
})(M.util);
